﻿Public Class fmMain
    Private wclIrDAReceiver As wclIrDAReceiver
    Private WithEvents wclIrDAClient As wclIrDAClient
    Dim WithEvents FFtp As wclObexFtpClient


    Private Sub fmMain_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        wclIrDAReceiver = New wclIrDAReceiver()
        wclIrDAClient = New wclIrDAClient()

        ' We use ObjectPush Profile so must set the profile's UUID.
        wclIrDAClient.Service = "OBEX"
        wclIrDAClient.Mode = wclIrDAConnectionMode.cmIrComm3Wire ' We need this for OBEX

        FFtp = Nothing
    End Sub

    Private Sub wclIrDAClient_OnConnect(Sender As Object, [Error] As Integer) Handles wclIrDAClient.OnConnect
        lbLog.Items.Add("Connect. Operation result: 0x" + [Error].ToString("X8"))
    End Sub

    Private Sub wclIrDAClient_OnCreateProcessor(Sender As Object, Connection As wclCommunication.wclClientDataConnection) Handles wclIrDAClient.OnCreateProcessor
        ' here we must create the data processor for the connection. In this demo
        ' we use OPPClient.
        FFtp = New wclObexFtpClient(Connection)
    End Sub

    Private Sub wclIrDAClient_OnDestroyProcessor(Sender As Object, Connection As wclCommunication.wclClientDataConnection) Handles wclIrDAClient.OnDestroyProcessor
        ' Do we have any data processor created?
        If Not (FFtp Is Nothing) Then
            ' Make sure it is our connection is goind to destroy.
            If Connection.Processor Is FFtp Then
                ' Ok, destroy the data processor here.
                FFtp.Dispose()
                FFtp = Nothing
            End If
        End If
    End Sub

    Private Sub wclIrDAClient_OnDisconnect(Sender As Object, Reason As Integer) Handles wclIrDAClient.OnDisconnect
        lbLog.Items.Add("Disconnected with reason: 0x" + Reason.ToString("X8"))
    End Sub

    Private Sub FFtp_OnChangeDirComplete(Sender As Object, [Error] As Integer, Description As String) Handles FFtp.OnChangeDirComplete
        lbLog.Items.Add("Change dir completed with result: 0x" + [Error].ToString("X8") + ". Description: " + Description)

        ProgressBar.Value = 0
        ProgressBar.Maximum = 0

        lvFiles.Items.Clear()
        FFtp.Dir()
    End Sub

    Private Sub FFtp_OnConnect(Sender As Object, [Error] As Integer, Description As String) Handles FFtp.OnConnect
        lbLog.Items.Add("OBEX session opened with result: 0x" + [Error].ToString("X8") + ". Description: " + Description)
    End Sub

    Private Sub FFtp_OnDeleteComplete(Sender As Object, [Error] As Integer, Description As String) Handles FFtp.OnDeleteComplete
        lbLog.Items.Add("Delete completed with result: 0x" + [Error].ToString("X8") + ". Description: " + Description)

        ProgressBar.Value = 0
        ProgressBar.Maximum = 0

        lvFiles.Items.Clear()
        FFtp.Dir()
    End Sub

    Private Sub FFtp_OnDirComplete(Sender As Object, [Error] As Integer, Description As String, Dirs() As wclCommunication.wclObexFileObject) Handles FFtp.OnDirComplete
        lbLog.Items.Add("Dir completed with result: 0x" + [Error].ToString("X8") + ". Description: " + Description)

        ProgressBar.Value = 0
        ProgressBar.Maximum = 0

        If Not (Dirs Is Nothing) Then
            For Each Obj As wclObexFileObject In Dirs
                Dim Item As ListViewItem = lvFiles.Items.Add(Obj.Name)
                If Obj.IsDirectory Then
                    Item.SubItems.Add("Folder")
                Else
                    Item.SubItems.Add("File")
                End If
                Item.SubItems.Add(Obj.Size.ToString())

                Dim Perm As String = ""
                If (Obj.Permissions And wclObexFilePermission.opRead) <> 0 Then
                    Perm = Perm + "R"
                End If
                If (Obj.Permissions And wclObexFilePermission.opWrite) <> 0 Then
                    Perm = Perm + "W"
                End If
                If (Obj.Permissions And wclObexFilePermission.opDelete) <> 0 Then
                    Perm = Perm + "D"
                End If
                Item.SubItems.Add(Perm)
                If Not Obj.Modified.Equals(DateTime.MinValue) Then
                    Item.SubItems.Add(Obj.Modified.ToString())
                Else
                    Item.SubItems.Add("")
                End If
                If Not Obj.Created.Equals(DateTime.MinValue) Then
                    Item.SubItems.Add(Obj.Created.ToString())
                Else
                    Item.SubItems.Add("")
                End If
                If Not Obj.Accessed.Equals(DateTime.MinValue) Then
                    Item.SubItems.Add(Obj.Accessed.ToString())
                Else
                    Item.SubItems.Add("")
                End If

                Item.SubItems.Add(Obj.Description)
            Next Obj
        End If
    End Sub

    Private Sub FFtp_OnDisconnect(Sender As Object, [Error] As Integer, Description As String) Handles FFtp.OnDisconnect
        lbLog.Items.Add("OBEX session closed with result: 0x" + [Error].ToString("X8") + ". Description: " + Description)
    End Sub

    Private Sub FFtp_OnGetComplete(Sender As Object, [Error] As Integer, Description As String, Stream As System.IO.Stream) Handles FFtp.OnGetComplete
        lbLog.Items.Add("File receiving completed with result: 0x" + [Error].ToString("X8") + ". Description: " + Description)

        ProgressBar.Value = 0
        ProgressBar.Maximum = 0

        ' We must destroy the stream object here.
        Stream.Close()
        Stream.Dispose()
    End Sub

    Private Sub FFtp_OnMakeDirComplete(Sender As Object, [Error] As Integer, Description As String) Handles FFtp.OnMakeDirComplete
        lbLog.Items.Add("Make dir completed with result: 0x" + [Error].ToString("X8") + ". Description: " + Description)

        ProgressBar.Value = 0
        ProgressBar.Maximum = 0

        lvFiles.Items.Clear()
        FFtp.Dir()
    End Sub

    Private Sub FFtp_OnProgress(Sender As Object, Size As UInteger, Position As UInteger) Handles FFtp.OnProgress
        ProgressBar.Maximum = Size
        ProgressBar.Value = Position
    End Sub

    Private Sub FFtp_OnPutComplete(Sender As Object, [Error] As Integer, Description As String, Stream As System.IO.Stream) Handles FFtp.OnPutComplete
        lbLog.Items.Add("File sending completed with result: 0x" + [Error].ToString("X8") + ". Description: " + Description)

        ProgressBar.Value = 0
        ProgressBar.Maximum = 0

        ' We must destroy the stream object here.
        Stream.Close()
        Stream.Dispose()
    End Sub

    Private Sub btClear_Click(sender As System.Object, e As System.EventArgs) Handles btClear.Click
        lbLog.Items.Clear()
    End Sub

    Private Sub fmMain_FormClosing(sender As System.Object, e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        wclIrDAClient.Disconnect()
    End Sub

    Private Sub btDiscover_Click(sender As System.Object, e As System.EventArgs) Handles btDiscover.Click
        lvDevices.Items.Clear()

        Dim Devices As wclIrDADevice() = Nothing
        ' Discover classic devices only.
        Dim Res As Int32 = wclIrDAReceiver.Discover(Devices)
        If Res <> wclErrors.WCL_E_SUCCESS Then
            MessageBox.Show("Failed to start discovering: 0x" + Res.ToString("X8"))
        Else
            If Not Devices Is Nothing Then
                For Each Device As wclIrDADevice In Devices
                    Dim Item As ListViewItem = lvDevices.Items.Add(Device.Address.ToString("X8"))
                    Item.SubItems.Add(Device.Name)
                Next Device
            End If
        End If
    End Sub

    Private Sub btDisconnect_Click(sender As System.Object, e As System.EventArgs) Handles btDisconnect.Click
        Dim Res As Int32 = wclIrDAClient.Disconnect()
        If Res <> wclErrors.WCL_E_SUCCESS Then
            MessageBox.Show("Disconnect failed: 0x" + Res.ToString("X8"))
        End If
    End Sub

    Private Sub btCloseSession_Click(sender As System.Object, e As System.EventArgs) Handles btCloseSession.Click
        If FFtp Is Nothing Then
            MessageBox.Show("Not connected")
        Else
            Dim Res As Int32 = FFtp.Disconnect("")
            If Res <> wclErrors.WCL_E_SUCCESS Then
                MessageBox.Show("Close session failed: 0x" + Res.ToString("X8"))
            End If
        End If
    End Sub

    Private Sub btOpenSession_Click(sender As System.Object, e As System.EventArgs) Handles btOpenSession.Click
        If FFtp Is Nothing Then
            MessageBox.Show("Not connected")
        Else
            Dim Res As Int32 = FFtp.Connect()
            If Res <> wclErrors.WCL_E_SUCCESS Then
                MessageBox.Show("Open session failed: 0x" + Res.ToString("X8"))
            End If
        End If
    End Sub

    Private Sub btConnect_Click(sender As System.Object, e As System.EventArgs) Handles btConnect.Click
        If wclIrDAClient.State <> wclClientState.csDisconnected Then
            MessageBox.Show("Client is connected")
        Else
            If lvDevices.SelectedItems.Count = 0 Then
                MessageBox.Show("Select device")
            Else
                Dim Addr As UInt32 = Convert.ToUInt32(lvDevices.SelectedItems(0).Text, 16)
                wclIrDAClient.Address = Addr
                Dim Res As Int32 = wclIrDAClient.Connect()
                If Res <> wclErrors.WCL_E_SUCCESS Then
                    MessageBox.Show("Failed to connect: 0x" + Res.ToString("X8"))
                End If
            End If
        End If
    End Sub

    Private Sub btSelectFile_Click(sender As System.Object, e As System.EventArgs) Handles btSelectFile.Click
        If openFileDialog.ShowDialog() = DialogResult.OK Then
            edFileName.Text = openFileDialog.FileName
        End If
    End Sub

    Private Sub btAbort_Click(sender As System.Object, e As System.EventArgs) Handles btAbort.Click
        If FFtp Is Nothing Then
            MessageBox.Show("Not connected")
        Else
            Dim Res As Int32 = FFtp.Abort("")
            If Res <> wclErrors.WCL_E_SUCCESS Then
                MessageBox.Show("Abort failed: 0x" + Res.ToString("X8"))
            End If
        End If
    End Sub

    Private Sub btSendFile_Click(sender As System.Object, e As System.EventArgs) Handles btSendFile.Click
        If FFtp Is Nothing Then
            MessageBox.Show("Not connected")
        Else
            If edFileName.Text = "" Then
                MessageBox.Show("Select file")
            Else
                Dim Stream As System.IO.FileStream = New System.IO.FileStream(edFileName.Text, System.IO.FileMode.Open)
                Dim Res As Int32 = FFtp.Put(System.IO.Path.GetFileName(edFileName.Text), "", Stream)
                If Res <> wclErrors.WCL_E_SUCCESS Then
                    MessageBox.Show("Send file failed: 0x" + Res.ToString("X8"))
                    Stream.Close()
                    Stream.Dispose()
                End If
            End If
        End If
    End Sub

    Private Sub btDir_Click(sender As System.Object, e As System.EventArgs) Handles btDir.Click
        If FFtp Is Nothing Then
            MessageBox.Show("Not connected")
        Else
            Dim Res As Int32 = FFtp.Dir()
            If Res <> wclErrors.WCL_E_SUCCESS Then
                MessageBox.Show("Dir failed: 0x" + Res.ToString("X8"))
            Else
                lvFiles.Items.Clear()
            End If
        End If
    End Sub

    Private Sub lvFiles_DoubleClick(sender As System.Object, e As System.EventArgs) Handles lvFiles.DoubleClick
        If lvFiles.SelectedItems.Count > 0 Then
            If FFtp Is Nothing Then
                MessageBox.Show("Not connected")
            Else
                If lvFiles.SelectedItems(0).SubItems(1).Text = "Folder" Then
                    Dim Res As Int32 = FFtp.ChangeDir(lvFiles.SelectedItems(0).Text)
                    If Res <> wclErrors.WCL_E_SUCCESS Then
                        MessageBox.Show("Change path failed 0x" + Res.ToString("X8"))
                    End If
                Else
                    Dim Stream As System.IO.FileStream = New System.IO.FileStream(".\" + lvFiles.SelectedItems(0).Text, System.IO.FileMode.OpenOrCreate, System.IO.FileAccess.ReadWrite)
                    Dim Res As Int32 = FFtp.Get(lvFiles.SelectedItems(0).Text, Stream)
                    If Res <> wclErrors.WCL_E_SUCCESS Then
                        MessageBox.Show("Get failed 0x" + Res.ToString("X8"))
                        Stream.Close()
                        Stream.Dispose()
                    End If
                End If
            End If
        End If
    End Sub

    Private Sub btRoot_Click(sender As System.Object, e As System.EventArgs) Handles btRoot.Click
        If FFtp Is Nothing Then
            MessageBox.Show("Not connected")
        Else
            Dim Res As Int32 = FFtp.ChangeDir("")
            If Res <> wclErrors.WCL_E_SUCCESS Then
                MessageBox.Show("Root failed 0x" + Res.ToString("X8"))
            End If
        End If
    End Sub

    Private Sub btDelete_Click(sender As System.Object, e As System.EventArgs) Handles btDelete.Click
        If lvFiles.SelectedItems.Count > 0 Then
            If FFtp Is Nothing Then
                MessageBox.Show("Not connected")
            Else
                Dim Res As Int32 = FFtp.Delete(lvFiles.SelectedItems(0).Text)
                If Res <> wclErrors.WCL_E_SUCCESS Then
                    MessageBox.Show("Delete failed 0x" + Res.ToString("X8"))
                End If
            End If
        End If
    End Sub

    Private Sub btMkDir_Click(sender As System.Object, e As System.EventArgs) Handles btMkDir.Click
        If FFtp Is Nothing Then
            MessageBox.Show("Not connected")
        Else
            Dim Res As Int32 = FFtp.MkDir(edNewDirName.Text)
            If Res <> wclErrors.WCL_E_SUCCESS Then
                MessageBox.Show("Make sire failed 0x" + Res.ToString("X8"))
            End If
        End If
    End Sub
End Class
