Public Class fmMain
    Dim WithEvents wclIrDAServer As wclIrDAServer

    Private Sub fmMain_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        wclIrDAServer.Close()
        wclIrDAServer = Nothing
    End Sub

    Private Sub fmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        wclIrDAServer = New wclIrDAServer()

        cbIasValueType.SelectedIndex = 0
    End Sub

    Private Sub btListen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btListen.Click
        Dim Res As Int32 = wclIrDAServer.Listen()
        If Res <> wclErrors.WCL_E_SUCCESS Then
            MessageBox.Show("Error: 0x" + Res.ToString("X8"))
        End If
    End Sub

    Private Sub btClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btClose.Click
        Dim Res As Int32 = wclIrDAServer.Close()
        If Res <> wclErrors.WCL_E_SUCCESS Then
            MessageBox.Show("Error: 0x" + Res.ToString("X8"))
        End If
    End Sub

    Private Sub btClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btClear.Click
        lbEvents.Items.Clear()
    End Sub

    Private Sub btDisconnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btDisconnect.Click
        If lvClients.SelectedItems.Count = 0 Then
            MessageBox.Show("Select client")
        Else
            Dim Res As Int32 = CType(lvClients.SelectedItems(0).Tag, wclIrDAServerClientConnection).Disconnect()
            If Res <> wclErrors.WCL_E_SUCCESS Then
                MessageBox.Show("Error: 0x" + Res.ToString("X8"))
            End If
        End If
    End Sub

    Private Sub btSend_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btSend.Click
        If lvClients.SelectedItems.Count = 0 Then
            MessageBox.Show("Select client")
        Else
            Dim Ansi() As Byte = System.Text.Encoding.ASCII.GetBytes(edText.Text)
            Dim Sent As UInt32 = 0
            Dim Res As Int32 = CType(lvClients.SelectedItems(0).Tag, wclIrDAServerClientConnection).Write(Ansi, Sent)
            If Res <> wclErrors.WCL_E_SUCCESS Then
                MessageBox.Show("Error: 0x" + Res.ToString("X8"))
            Else
                MessageBox.Show("Sent: " + Sent.ToString() + " from " + Ansi.Length.ToString())
            End If
        End If
    End Sub

    Private Sub btGet_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btGet.Click
        If lvClients.SelectedItems.Count = 0 Then
            MessageBox.Show("Select client")
        Else
            Dim Client As wclIrDAServerClientConnection = CType(lvClients.SelectedItems(0).Tag, wclIrDAServerClientConnection)

            ' Get read buffer.
            Dim Size As UInt32 = 0
            Dim Res As Int32 = Client.GetReadBufferSize(Size)
            If Res <> wclErrors.WCL_E_SUCCESS Then
                lbEvents.Items.Add("Get read buffer error: 0x" + Res.ToString("X8"))
            Else
                edReadBuffer.Text = Size.ToString()
            End If

            ' Get write buffer.
            Size = 0
            Res = Client.GetWriteBufferSize(Size)
            If Res <> wclErrors.WCL_E_SUCCESS Then
                lbEvents.Items.Add("Get write buffer error: 0x" + Res.ToString("X8"))
            Else
                edWriteBuffer.Text = Size.ToString()
            End If
        End If
    End Sub

    Private Sub btSet_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btSet.Click
        If lvClients.SelectedItems.Count = 0 Then
            MessageBox.Show("Select client")
        Else
            Dim Client As wclIrDAServerClientConnection = CType(lvClients.SelectedItems(0).Tag, wclIrDAServerClientConnection)

            ' Set read buffer.
            Dim Size As UInt32 = Convert.ToUInt32(edReadBuffer.Text)
            Dim Res As Int32 = Client.SetReadBufferSize(Size)
            If Res <> wclErrors.WCL_E_SUCCESS Then
                lbEvents.Items.Add("Set read buffer error: 0x" + Res.ToString("X8"))
            End If

            ' Set write buffer.
            Size = Convert.ToUInt32(edWriteBuffer.Text)
            Res = Client.SetWriteBufferSize(Size)
            If Res <> wclErrors.WCL_E_SUCCESS Then
                lbEvents.Items.Add("Set write buffer error: 0x" + Res.ToString("X8"))
            End If
        End If
    End Sub

    Private Sub btAddRecord_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btAddRecord.Click
        Select Case cbIasValueType.SelectedIndex
            Case 0
                Dim Res As Integer = wclIrDAServer.AddIasRecord("IrDAFramework", "Integer value", 1234567)
                If Res <> wclErrors.WCL_E_SUCCESS Then
                    lbEvents.Items.Add("Add IAS record error: 0x" + Res.ToString("X8"))
                End If

            Case 1
                Dim Arr As Byte() = {1, 2, 3, 4, 5, 6, 7, 8}
                Dim Res As Integer = wclIrDAServer.AddIasRecord("IrDAFramework", "Octet Sequence", Arr)
                If Res <> wclErrors.WCL_E_SUCCESS Then
                    lbEvents.Items.Add("Add IAS record error: 0x" + Res.ToString("X8"))
                End If

            Case 2
                Dim Arr As Byte() = {85, 115, 101, 114, 32, 115, 116, 114, 105, 110, 103}
                Dim Res As Integer = wclIrDAServer.AddIasRecord("IrDAFramework", "User string", wclIrDACharSet.csAscii, Arr)
                If Res <> wclErrors.WCL_E_SUCCESS Then
                    lbEvents.Items.Add("Add IAS record error: 0x" + Res.ToString("X8"))
                End If
        End Select
    End Sub

    Private Sub wclIrDAServer_OnClosed(ByVal sender As Object, ByVal Reason As Integer) Handles wclIrDAServer.OnClosed
        lbEvents.Items.Add("Server closed: 0x" + Reason.ToString("X8"))

        lvClients.Items.Clear()

        edReadBuffer.Text = ""
        edWriteBuffer.Text = ""
    End Sub

    Private Sub wclIrDAServer_OnConnect(ByVal Sender As Object, ByVal Client As wclIrDA.wclIrDAServerClientConnection, ByVal [Error] As Integer) Handles wclIrDAServer.OnConnect
        lbEvents.Items.Add("Client connected: " + Client.Address.ToString("X8") + " error: 0x" + [Error].ToString("X8"))

        If [Error] = wclErrors.WCL_E_SUCCESS Then
            Dim Item As ListViewItem = lvClients.Items.Add(CType(Client, wclIrDAServerClientConnection).Address.ToString("X8"))
            Item.SubItems.Add(CType(Client, wclIrDAServerClientConnection).Name)
            Item.Tag = Client
        End If
    End Sub

    Private Sub wclIrDAServer_OnData(ByVal Sender As Object, ByVal Client As wclIrDA.wclIrDAServerClientConnection, ByVal Data() As Byte) Handles wclIrDAServer.OnData
        If Data IsNot Nothing AndAlso Data.Length > 0 Then
            Dim Str As String = System.Text.Encoding.ASCII.GetString(Data)

            lbEvents.Items.Add("Received: " + Str + " from " + Client.Address.ToString("X8"))
        End If
    End Sub

    Private Sub wclIrDAServer_OnDisconnect(ByVal Sender As Object, ByVal Client As wclIrDA.wclIrDAServerClientConnection, ByVal Reason As Integer) Handles wclIrDAServer.OnDisconnect
        lbEvents.Items.Add("Client disconnected: " + CType(Client, wclIrDAServerClientConnection).Address.ToString("X8") + " reason: 0x" + Reason.ToString("X8"))

        Dim i As Integer
        For i = 0 To lvClients.Items.Count - 1
            If lvClients.Items(i).Tag Is Client Then
                lvClients.Items.RemoveAt(i)
                Exit For
            End If
        Next i
    End Sub

    Private Sub wclIrDAServer_OnListen(ByVal sender As Object, ByVal e As System.EventArgs) Handles wclIrDAServer.OnListen
        lbEvents.Items.Add("Server listening")
    End Sub
End Class
